# JSServe

![CI](https://github.com/SimonDanisch/JSServe.jl/workflows/CI/badge.svg) [![Codecov](https://codecov.io/gh/SimonDanisch/JSServe.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/SimonDanisch/JSServe.jl)


Easy way of building interactive applications from Julia.
Uses Hyperscript to create HTML descriptions, and allows to execute Javascript & building of widgets. It also supports an offline mode, that exports your interactive app to a folder, and optionally records a statemap for all UI elements, so that a running Julia process isn't necessary anymore.

Have a look at the [examples](https://github.com/SimonDanisch/JSServe.jl/tree/master/examples), or check out the most outstanding ones:
## Markdown support
https://github.com/SimonDanisch/JSServe.jl/blob/master/examples/markdown.jl
![markdown_vol](https://user-images.githubusercontent.com/1010467/88916397-48513480-d266-11ea-8741-c5246f7f2395.gif)


## Renchon et al., Argonne National Laboratory, unpublished
https://simondanisch.github.io/WGLDemos/soil/
![soil](https://user-images.githubusercontent.com/1010467/88913137-aa0ea000-d260-11ea-81b6-3e71ff18ff03.gif)


## [Oceananigans](https://github.com/CliMA/Oceananigans.jl)
https://simondanisch.github.io/WGLDemos/oceananigans/
![ocean](https://user-images.githubusercontent.com/1010467/88912988-6d42a900-d260-11ea-8d87-1f3eea552d1b.gif)

## Smarthome dashboard:

https://github.com/SimonDanisch/SmartHomy/blob/master/web_app.jl
![image](https://user-images.githubusercontent.com/1010467/88916549-8d756680-d266-11ea-8d38-cd57640e1495.png)


## Interactive Notebook:

https://nextjournal.com/Lobatto/FitzHugh-Nagumo
![simulation](https://user-images.githubusercontent.com/1010467/88912834-2f458500-d260-11ea-9a49-5e17f769ff53.gif)


## Sponsors

<img src="https://github.com/JuliaPlots/Makie.jl/blob/master/assets/BMBF_gefoerdert_2017_en.jpg?raw=true" width="300"/>
Förderkennzeichen: 01IS10S27, 2020
